package com.bekvon.bukkit.residence.text;

import java.util.HashMap;

import org.bukkit.ChatColor;

import com.bekvon.bukkit.residence.Residence;

public final class LanguageLoader {

    private static HashMap<String, String> text;

    private LanguageLoader() {
        text = new HashMap<String, String>();
        loadText();
    }

    public static String getString(String key) {
        return getString(key, (String[]) null);
    }

    public static String getString(String key, String ... messageArguments) {
        String output = text.get(key);
        if (output == null) {
            output = "<missing language key: " + key + ">";
        }
        if (messageArguments != null) {
            for (int i = 0; i < messageArguments.length; i++) {
                output = output.replaceAll("%" + (i + 1), messageArguments[i]);
            }
        }
        output = ChatColor.translateAlternateColorCodes("&".toCharArray()[0], output);
        return output;
    }

    public String getCurrentLanguage() {
        return Residence.getConfigManager().getLanguage();
    }

    private void loadText() {
        String language = getCurrentLanguage();
        //TODO
    }
}
